#Programma di riduzione da matching m:n a matching 1:1
#con condizione di selezione dei valori di r maggiori di 1
#Parametri di input contenuti nel file "paramOtoO.R": 
#percorso = percorso del file "inputOtoO.txt" contenente una matrice di AxB righe e 3 colonne : i(id file A), j 
#(id file B), r, p_post
#percorso_out= percorso del file di output "LPOut.txt"



#carica pacchetto lpSolve
library("lpSolve")
library("RODBC")
#lettura parametri input 
source("paramOtoO.R")

#lettura dei dati
#connssione al db relais

con <- odbcConnect("relais",case="mysql")
strInput = paste(paste('select * from ', inputOtoOTableName),';')
w <- sqlQuery(con, strInput, as.is = TRUE)

# seleziona solo gli elementi con peso maggiore di 1
#dat=w[w[,4]>1,] 

# seleziona solo gli elementi con p_post maggiore di 0.5
dat=w[w[,5]>0.5,] 


#separa le prime tre colonne dall'ultima

#indici file A
A=cbind(unique(dat[,1]),1:length(unique(dat[,1]))) 
#indici file B
B=cbind(unique(dat[,2]),1:length(unique(dat[,2]))) 
colnames(A)=c('I','A')
colnames(B)=c('J','B')

#creazione del data set di analisi con i record indicizzati
dat=merge(B,dat)
dat=merge(A,dat)
dat=t(dat)
n=nrow(A); m=nrow(B) 

#crea la matrice dei vincoli di riga e colonna e la inizializza a zero
vincoli=array(rep(0,(n+m)*ncol(dat)), dim=c(n+m,ncol(dat)))

# aggiunge gli uno nella matrice dei vincoli di riga e colonna
p=rbind(matrix(rep(dat[2,],n),c(n,ncol(vincoli)),byrow=TRUE),
        matrix(rep(as.numeric(dat[4,])+n,m),c(m,ncol(vincoli)),byrow=TRUE))
		
#matrice dei vincoli
vincoli[as.numeric(p)==row(vincoli)]=1 
#matrice delle disuguaglianze
vindir=rep('<=',m+n)  
#upper bound dei vincoli       
uno=rep(1,m+n)  
#coefficienti della funzione obiettivo             
coeff=dat[6,]    
#solutore       
soluzione=lp ("max", coeff, vincoli, vindir, uno)   
 
#unisce la colonna soluzione ai dati
dat=rbind(dat,soluzione$solution)   
#seleziona gli abbinati
coppie=t(dat[c(1,3,5,6,7),dat[8,]>0.999])   
coppieNew <- as.data.frame(coppie)

sqlSave(con, coppieNew, LinkOtoOTableName, rownames = FALSE)
odbcClose(con)
