#Programma valido per una variabile latente dicotomica e k variabili manifeste dicotomiche
#vincolo sul numero di variabili: numero variabili >= 3
#lettura del file contenente i parametri di input:
#nvar= numero variabili manifeste
#contingencyTableName= nome della tabella che contiente la matrice di contingenza
#muTableName=nome della tabella che contenente i parametri stimati, nel caso di stima **affidabile** del modello
#percorso_fail=path del file contenete le condizionate alla variabile latente, nel caso di stima ** non affidabile** del modello
#eps,iter parametri del modello EM con valori di default

library("RODBC")
source("param.R")

#connssione al db relais

con <- odbcConnect("relais",case="mysql")
strInput <- paste(paste('select * from ', contingencyTableName),';')
conting <- sqlQuery(con, strInput)
nomimatvar <- names(conting)[1:nvar]
names(conting) [nvar+1] = 'Freq'

strInput <- paste(paste('select * from ', varmuTableName),';')
margins <- sqlQuery(con, strInput)

m_att <- rep(1,2^nvar)
u_att <- rep(1,2^nvar)

for (j in 1:2^nvar)
   for (i in 1:nvar) {
       m_att[j]<- m_att[j] * (margins[margins$VARIABLE==nomimatvar[i] & margins$COMPARISON==conting[j,i],3])
       u_att[j]<- u_att[j] * (margins[margins$VARIABLE==nomimatvar[i] & margins$COMPARISON==conting[j,i],4])
   }
mfreq <- margins[1,5]

r_att <- m_att/u_att
p_post <- m_att*mfreq/(m_att*mfreq+u_att*(1-mfreq))
fm_obs <- conting$Freq*p_post
fu_obs <- conting$Freq*(1-p_post)

fm_obs=round(fm_obs, digits=5)
fu_obs=round(fu_obs, digits=5)
m_att=round(m_att, digits=5)
u_att=round(u_att, digits=5)
r_att=round(r_att, digits=5)
p_post=round(p_post, digits=5)

r_out <- cbind(conting[,1:nvar],fm_obs,fu_obs,m_att,u_att,r_att,p_post)

r_out <- r_out [order(r_out$r_att , decreasing = FALSE ),]

prec_oss <- rep(0,2^nvar)
recl_oss <- rep(0,2^nvar)
for (j in 1:2^nvar) {
   prec_oss[j] <- sum(r_out$fm_obs[j:2^nvar])/(sum(r_out$fm_obs[j:2^nvar])+sum(r_out$fu_obs[j:2^nvar]))
   recl_oss[j] <- sum(r_out$fm_obs[j:2^nvar])/sum(r_out$fm_obs)
}

prec_oss=round(prec_oss, digits=5)
recl_oss=round(recl_oss, digits=5)

r_out <- cbind(r_out,prec_oss,recl_oss)
names(r_out)[-(1:nvar)] <- c("F_M","F_U","M","U","R","P_POST","PRECISION","RECALL")


# inserisco i nomi delle matvar per creare la tabella

sqlSave(con, r_out, muTableName, rownames = FALSE)

odbcClose(con)